#lang errortrace racket
#|
(define (if c t e)
  (cond [c t] [else e]))

(define (div x y)
  (if (= y 0) 'error (/ x y)))

; (div 10 0)
(define (factorial x)
  (if (<= x 0) 1 (* x (factorial (- x 1)))))|#

;; (factorial 10)

(define (if b then-branch else-branch)
   (cond [b (then-branch)] [else (else-branch)]))

(define (factorial n)
  (if (= n 0) (lambda () (displayln "*") 1)
    (lambda ()
      (displayln n)
      (* n (factorial (- n 1))))))

;(factorial 10)

(define (thunk-repeat n th)
  (cond [(> n 0)
          (th)
          (thunk-repeat (- n 1) th)]))
;; (thunk-repeat 3
;;   (thunk (displayln "T") (sleep 1) "foo"))

(define (promise-repeat n th)
  (cond [(> n 0)
          (force th)
          (promise-repeat (- n 1) th)]))
;; (displayln "~~~~~~~~~~~")
;; (promise-repeat 3
;;   (delay (displayln "P") (sleep 1) "foo"))

(define p (delay (displayln "X") (sleep 1) "bar"))
#|
(displayln "~~~~~~~~~~~")
(thunk-repeat 3
  (thunk (force p)
         (force p)))
(force p)|#
;; (define (factorial x)
;;   (* x (factorial (- x 1))))
;;   (cond [(<= x 0) 1]
;;         [else (* x (factorial (- x 1)))]))

;(factorial 10)

(define (map f l)
  (cond [(empty? l) empty]
        [else
        (cons (f (first l)) (map f (rest l)))]))
#|
(define (powers-of-two)
  (define (powers-of-two-iter n)
    (cons n (thunk (powers-of-two-iter (* 2 n)))))
  (powers-of-two-iter 1))|#

(define (stream-get s) (car s))
(define (stream-next s) ((cdr s)))


#|


(powers-of-two)


(stream-get (powers-of-two))
(define 2.. (stream-next (powers-of-two)) )

2..

(stream-get 2..)
(define 4.. (stream-next 2..))

4..

(stream-next 4..)


4..
2..|#

(define stream-first stream-get)
(define stream-rest stream-next)

(define (count-until predicate s)
  (define (count-until-iter count s)
    (cond [(predicate (stream-first s))
           (count-until-iter (+ count 1) (stream-rest s))]
          [else count]))
  (count-until-iter 0 s))


(define (powers-of-two)
  (define (powers-of-two-iter n)
    (cons
      n
      (thunk (powers-of-two-iter (* n 2)))))
  (powers-of-two-iter 1))


(count-until (lambda (x) (<= x 10)) (powers-of-two))
(count-until (lambda (x) (= x 1)) (powers-of-two))
;(count-until (lambda (x) #t) (powers-of-two))

;; (check-equal? 3 (count-until (powers-of-two) (lambda (x) (< x 8))))
;; (check-equal? 0 (count-until (powers-of-two) (lambda (x) (<= x 0))))
;; (check-equal? 3 (count-until (powers-of-two) (curryr < 8)))  ; Reverse Currying
;; (check-equal? 0 (count-until (powers-of-two) (curryr <= 0))) ; Reverse Currying








